from django.shortcuts import render, redirect  
from discussion.forms import EmployeeForm , ThreadForm, TopicForm
from discussion.models import Employee, Subject_Student, Person, Subject, Topic, Thread
# Create your views here.  
def emp(request):  
    if request.method == "POST":  
        form = EmployeeForm(request.POST)  
        if form.is_valid():  
            try:  
                form.save()  
                return redirect('/show')  
            except:  
                pass  
    else:  
        form = EmployeeForm()  
    return render(request,'index.html',{'form':form})  
def show(request):  
    employees = Employee.objects.all()  
    return render(request,"show.html",{'employees':employees})  
def edit(request, id):  
    employee = Employee.objects.get(id=id)  
    return render(request,'edit.html', {'employee':employee})  
def update(request, id):  
    employee = Employee.objects.get(id=id)  
    form = EmployeeForm(request.POST, instance = employee)  
    if form.is_valid():  
        form.save()  
        return redirect("/show")  
    return render(request, 'edit.html', {'employee': employee})  
def destroy(request, id):  
    employee = Employee.objects.get(id=id)  
    employee.delete()  
    return redirect("/show")


def default(request):  
    return render(request, 'base.html' ,{'pid':101})

def show_subjects(request, id):
	try:
		person = Person.objects.get(pid=id)
	except:
		return redirect('/')
	subject_student = Subject_Student.objects.filter(student = person)
	return render(request,"subjects.html",{'subject_student':subject_student})

def show_topics(request, id):
	try:
		subject = Subject.objects.get(sub_code=id)
	except:
		return redirect('/')
	topics = Topic.objects.filter(subject = subject)
	if request.method == "POST":
		form = TopicForm(request.POST)
		
		if form.is_valid():
			try:
				topic = form.save(commit=False)
				topic.subject = subject
				form.save()	

				return redirect('/topics/' + str(id))
			except:
				pass
	else:
		form = TopicForm()
	return render(request,'discussion_topics.html',{'form':form, 'sub_code':id, 'topics':topics})

def show_threads(request, id):
	try:
		topic = Topic.objects.get(id=id)
	except:
		return redirect('/')
	threads = Thread.objects.filter(topic = topic)
	if request.method == "POST":
		person = Person.objects.get(pid=101)
		form = ThreadForm(request.POST)
		
		if form.is_valid():
			try:
				thread = form.save(commit=False)
				thread.topic = topic
				thread.person = person
				form.save()

				return redirect('/threads/' + str(id))
			except:
				pass
	else:
		form = ThreadForm()
	return render(request,'discussion_thread.html',{'form':form, 'topic_id':id, 'threads':threads}) 